"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GradientDiv = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var react_resize_detector_1 = require("react-resize-detector");
var GradientDiv = function (props) {
    var _a = (0, react_resize_detector_1.useResizeDetector)(), width = _a.width, height = _a.height, ref = _a.ref;
    var _b = (0, react_1.useState)(false), isOverflowX = _b[0], setIsOverflowX = _b[1];
    var tooltip = props.tooltip, children = props.children, onChangeOverflow = props.onChangeOverflow, gradientColorRGB = props.gradientColorRGB, gradientStages = props.gradientStages, gradientAreaWidth = props.gradientAreaWidth, divProps = __rest(props, ["tooltip", "children", "onChangeOverflow", "gradientColorRGB", "gradientStages", "gradientAreaWidth"]);
    var className = props.className ? props.className : "";
    var alignment = props.alignment == "right" ? "right" : "left";
    var gradientAreaWidthInternal = !(0, lodash_1.isNil)(gradientAreaWidth) &&
        (0, lodash_1.isInteger)(gradientAreaWidth) &&
        gradientAreaWidth > 20
        ? gradientAreaWidth
        : !(0, lodash_1.isNil)(width)
            ? width
            : "20%";
    var gradientStagesInternal = gradientStages
        ? gradientStages
        : [65, 75, 85];
    var rgb = gradientColorRGB
        ? gradientColorRGB
        : { r: 255, g: 255, b: 255 };
    (0, react_1.useEffect)(function () {
        var overflow = ref.current.scrollWidth - ref.current.clientWidth > 0;
        if (isOverflowX != overflow && onChangeOverflow)
            onChangeOverflow(overflow);
        setIsOverflowX(overflow);
    }, [width, children]);
    return (react_1.default.createElement("div", __assign({ ref: ref }, divProps, { title: isOverflowX && tooltip ? tooltip : "", className: "gradient-div w-full relative whitespace-nowrap overflow-hidden grid ".concat(alignment == "right" && !isOverflowX
            ? "text-right"
            : "text-left", " ").concat(className) }),
        children,
        isOverflowX && (react_1.default.createElement("div", { className: "absolute gradient-div-tail", style: {
                height: height,
                top: 0,
                right: 0,
                width: gradientAreaWidthInternal,
                background: "linear-gradient(90deg, rgba(".concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",0) 0%, rgba(").concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",0.25) ").concat(gradientStagesInternal[0], "%, rgba(").concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",0.5) ").concat(gradientStagesInternal[1], "%, rgba(").concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",0.75) ").concat(gradientStagesInternal[2], "%, rgb(").concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, "))")
            } }))));
};
exports.GradientDiv = GradientDiv;
exports.default = exports.GradientDiv;
//# sourceMappingURL=gradient-div.js.map