//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useState, useRef } from "react";
import { isNonEmptyString, isObject } from "primeobjects-helper-util/build/cjs/core";
import { isFunction } from "lodash";
export var Resizer = function (props) {
    var className = isNonEmptyString(props.className) ? props.className : "";
    var style = isObject(props.style) ? props.style : {};
    var _a = useState({ x: 0, y: 0 }), pos = _a[0], setPos = _a[1];
    var _b = useState({
        width: 100,
        height: 100
    }), size = _b[0], setSize = _b[1];
    var r = useRef(null);
    var initial = function (e) {
        setPos({ x: e.clientX, y: e.clientY });
        setSize({
            width: r.current.offsetWidth,
            height: r.current.offsetHeight
        });
    };
    var onResize = function (e, type) {
        var width = size.width + e.clientX - pos.x;
        var height = size.height + e.clientY - pos.y;
        switch (type) {
            case "width": {
                r.current.style.width = "".concat(width, "px");
                if (isFunction(props.onResize))
                    props.onResize(width, size.height);
                break;
            }
            case "height": {
                r.current.style.height = "".concat(height, "px");
                if (isFunction(props.onResize))
                    props.onResize(size.width, height);
                break;
            }
            default: {
                r.current.style.width = "".concat(width, "px");
                r.current.style.height = "".concat(height, "px");
                if (isFunction(props.onResize))
                    props.onResize(width, height);
                break;
            }
        }
        e.stopPropagation();
        e.preventDefault();
    };
    return (React.createElement("div", { className: "relative overflow-none ".concat(className), style: __assign({ width: "fit-content", height: "fit-content" }, style) },
        React.createElement("div", { ref: r, style: __assign({ minWidth: "100%", minHeight: "100%", width: "fit-content", height: "fit-content" }, style) }, props.children),
        React.createElement("div", { className: "absolute resizer-handler", style: {
                cursor: "col-resize",
                width: 3,
                top: 3,
                right: 0,
                height: "calc(100% - 6px)",
                resize: "horizontal",
                background: "transparent"
            }, draggable: "true", onDragStart: initial, onDrag: function (e) { return onResize(e, "width"); } }),
        React.createElement("div", { className: "absolute resizer-handler", style: {
                cursor: "row-resize",
                height: 3,
                bottom: 0,
                left: 3,
                width: "calc(100% - 6px)",
                resize: "vertical",
                background: "transparent"
            }, draggable: "true", onDragStart: initial, onDrag: function (e) { return onResize(e, "height"); } }),
        React.createElement("div", { className: "absolute resizer-handler", style: {
                cursor: "se-resize",
                width: 3,
                height: 3,
                bottom: 0,
                right: 0,
                background: "transparent"
            }, draggable: "true", onDragStart: initial, onDrag: function (e) { return onResize(e, "both"); } })));
};
export default Resizer;
//# sourceMappingURL=resizer.js.map